========
Overview
========

femSTEM.org is an effort to connect groups focused on encouraging girls and women in areas of Science, Technology, Engineering, and Math. This site is to serve as a searchable index and growing database for these organizations.

<br />
==========
Background
==========

In January of 2013, I wrote my first lines of code. As I’ve grown in my coding abilities, my life has changed for the awesome. I’ve learned new ways to think about the world, my career opportunities have expanded exponentially, and my confidence has increased as I master new skills.

Prior to this experience, I always assumed programming was for men who were good at math. No one ever told me I could be a programmer.

I believe there are a lot of women like me, who are curious about programming and STEM, who need some extra encouragement to jump in.

As a result, I developed a passion for helping other women get involved with programming so they can experience expanded opportunities with STEM careers.

I wanted to take this passion and get involved. I found dozens of groups with a female + STEM mission, but I also found disorganization. Each group has a presence in different mediums and not all groups are represented across a single platform (like Meetup.com, Google Groups, Google+, Facebook Groups, Facebook Fan Pages, Twitter, and some do not have websites). In order to prevent reinventing the wheel and to save time, energy, and money if someone would like to start a female and STEM focused organizations, I want to create a single site and searchable index where people can find information on what groups already exist and how to get plugged-in with those groups.

Over time, I would also like to build out this database to include educational resources, articles, events, and profiles of individuals in these fields.

<br />
====================
Skills
====================

femSTEM.org is also a project to practice the following skills:

* HTML5
* CSS3
* Bootstrap
* Responsive Design
* JavaScript
* jQuery
* Form Validation
* AJAX 
* JSON
* MongoDB
* Node.js
* Expression Framework
* Backlift App (TBD)
* Heroku (TBD)

<br />
===================================
Process Outline
===================================
<br />
### Phase 1 (Completed)
Research:
* Searched Internet via several mediums to see if a version of this project idea was already in use somewhere. Did not find one so proceeded with project.

<br />
### Phase 2 (Completed)
Planning and Scale:
* Created mind-map to plan scale of entire project.
* For time purposes, scaled back project elements to include just one branch of overall project (groups).
* Used mind-map again to map out tools used for this project.
* Created task list and timeline.


<br />
### Phase 3 (Completed)
Data Collection:

(Note: Began collecting data four weeks prior to project start, as new data was discovered, thus the use of Excel, rather than less familiar programming tools.)
* Searched and bookmarked femSTEM groups via several mediums like Meetup.com, Google Groups, Google+, Facebook Groups, Facebook Fan Pages, Twitter, etc. 
* Collected and input data via Excel.


<br />
### Phase 4 (Completed)
Server-Side Tools and Frameworks:

(Note: Chose JavaScript tools to gain a deeper understanding of this language.
Found these tools required Xcode)
* Joined Apple Developer Network
* Found and downloaded Xcode from Apple that was compatible with my current Mac OS X software (10.6.8, Snow Leopard)
* Discovered Xcode 4 was needed and was not compatible with my current software
* For time reasons, switched to command line tools that did not require full and latest version of Xcode.
* Created Heroku account for hosting.
* Installed Node.js to provide RESTful services that the client application needs to manipulate the data.  
* Installed Express framework for basic HTTP infrastructure.
* Installed MongoDB to store data.
* Considered and installed MongoDB GUI named MongoHub. May not use this tool, which required installation of the following: 
  * BWToolkitFramework.framework 
  * Sparkle.framework 
  * MCPKit_bundled.framework 
  * RegexKit.framework
  * Boost libraries 
  * MongoDB client libraries


<br />
### Phase 5 (Completed)
First File Commit:
* Built basic file structures, making sure all files were linking correctly, and uploaded to GitHub:
  * HTML index
  * CSS folder
  * JS folder
  * Img folder

<br />
### Phase 6 (In Process)
Data:
* Add data to file structures:
  * Convert Excel to CSV
  * Convert CSV to JSON
  * Add JSON to MongoDB

<br />
### Phase 7
Forms:
* Connect Bootstrap forms with server-side.

<br />
### Phase Last
Prettify:
* Once programming and back-end structure complete, further build client side design.
