var express = require('express'),
    group = require('./routes/groups');
 
var app = express();
 
app.configure(function () {
    app.use(express.logger('dev'));     /* 'default', 'short', 'tiny', 'dev' */
    app.use(express.bodyParser());
});
 
app.get('/groups', group.findAll);
app.get('/groups/:id', group.findById);
app.post('/groups', group.addGroup);
app.put('/groups/:id', group.updateGroup);
app.delete('/groups/:id', group.deleteGroup);
 
app.listen(27017);
console.log('Listening on port 27017...'); 